function priklad_Galerkin_2d()


log = sprintf('Baze: e_i(x,y) = x^*(1-x)*y^i*(1-y), i=1,...,n\n');
disp(log)

for n=1:20

    b = zeros(n,1);
    for i=1:n
        b(i) = (1/(i+1)-1/(i+2))^2;
    end

    A = zeros(n,n);
    syms x y
    for i=1:n
        ei1 = (i*x^(i-1)*(1-x)-x^i)*y^i*(1-y);
        ei2 = x^i*(1-x)*(i*y^(i-1)*(1-y)-y^i);
        for j=1:n
            ej1 = (j*x^(j-1)*(1-x)-x^j)*y^j*(1-y);
            ej2 = x^j*(1-x)*(j*y^(j-1)*(1-y)-y^j);
            fij = ei1*ej1+ei2*ej2;
            A(i,j) = int(int(fij,x,0,1),y,0,1);
        end
    end

    alfa = A\b;


    log = sprintf('2d Galerkinova aproximace n=%d: cond(A)=%g',n,cond(A));
    disp(log)


    %
    % vykresli reseni
    %
    x = 0:0.01:1;
    y = x;
    [X,Y] = meshgrid(x,y);
    U = zeros(size(X));
    for i=1:n
        U = U + alfa(i) * X.^i.*(1-X).*Y.^i.*(1-Y);
    end
    %
    close all
    surface(X,Y,U)
    hold off
    pause
    
end
