function [A,b] = Galerkin(n)

% [A,b] = Galerkin(n)
%           sestavi soustavu lin. rovnic pro Galerkinovu aproximaci ulohy
%            -u''(x) = 1 v (0,1)
%            u(0) = u(1) = 0
%           na podprostoru (ei(x)), kde ei(x) = x^i*(1-x)

A = zeros(n,n);
b = zeros(n,1);

for i=1:n
    b(i) = -1/(i+2)+1/(i+1);
    for j=1:n
        A(i,j) = (i+1)*(j+1)/(i+j+1)-((i+1)*j+(j+1)*i)/(i+j)+i*j/(i+j-1);
    end
end
