function u = analyt_reseni(xi,ki,fi,x)

% u = analyt_reseni(xi,ki,fi,x)
%           resi ulohu
%             -(k(x)*u'(x))' = f(x) na (a=xi(1),b=xi(N+1))
%             u(a) = u(b) = 0
%           kde
%           k(x) = ki(i) pro x z (xi(i-1),xi(i)),
%           f(x) = fi(i) pro x z (xi(i-1),xi(i)),
%           u je reseni v bodech x(k).
%           xi,ki,fi ... sloupcove vektory,
%           dim(xi) = N+1,
%           dim(ki)=dim(fi)=N.

N = length(xi)-1;

a = xi(1);
b = xi(N+1);

M = [ a , zeros(1,N-1) , 1 , zeros(1,N-1) ; ...
      spdiags([xi(2:N),-xi(2:N)],0:1,N-1,N) , spdiags([ones(N-1,1),-ones(N-1,1)],0:1,N-1,N) ; ...
      spdiags([ki(1:N-1),-ki(2:N)],0:1,N-1,N) , sparse(N-1,N) ; ...
      zeros(1,N-1) , b , zeros(1,N-1) , 1 ];

v = [ fi(1)*a^2/(2*ki(1)) ; ...
      xi(2:N).^2 .* ( fi(1:N-1)./ki(1:N-1) - fi(2:N)./ki(2:N) ) / 2 ; ...
      xi(2:N) .* ( fi(1:N-1) - fi(2:N) ) ; ...
      fi(N)*b^2/2/ki(N) ];
  
AB = M\v;
A = AB(1:N);
B = AB(N+1:2*N);
  
n = length(x);
u = x;
for i=1:n
    for idx=1:N
        if x(i)>=xi(idx) && x(i)<=xi(idx+1)
            break;
        end
    end
    u(i) = -fi(idx)*x(i)^2/2/ki(idx) + A(idx)*x(i) + B(idx);
end
